#
# MAD Nuke Mod
# CvMADNukeEventManager
# 

from CvPythonExtensions import *

import CvUtil
import CvEventManager
import sys
import PyHelpers
import CvConfigParser
import math
import time
import CvMADNukesManager
import CvScreenEnums 
			
gc = CyGlobalContext()	


PyPlayer = PyHelpers.PyPlayer
PyGame = PyHelpers.PyGame()

localText = CyTranslator()

# Change this value to false if nuke strikes should not completely destroy 
# cities.
# Default value is true
g_bNukesDestroyCities = true

# Change this value to false if nuke strikes should not change the plot that is
# hit into an ocean plot. When this value is set to true then the 
# g_bNukesDestroyUnits, g_bNukeStrikesLeaveRuins and g_bNukesDestroyCities are 
# automatically assumed to be true.
# Default value is true
g_bNukesAlterLandscape = true

# Change this value to change what type terrain the nuked plot will turn to if
# g_bNukesAlterLandscape is set to true. The current possible values for this
# option are:
# - TERRAIN_GRASS
# - TERRAIN_PLAINS
# - TERRAIN_DESERT
# - TERRAIN_TUNDRA
# - TERRAIN_SNOW
# - TERRAIN_COAST
# - TERRAIN_OCEAN
# - TERRAIN_PEAK
# - TERRAIN_HILL

# Default value is "TERRAIN_COAST"
g_strAlterLandscapeTerrain = "TERRAIN_COAST"

# Change this value to false if the vanilla unit nuke strike survival code
# should be used instead of completely wiping them out when a nuke strikes a
# city.
# Default value is true
g_bNukesDestroyUnits = true

# Change this value to false if nuke strikes should leave city ruins.
# Default value is true
g_bNukeStrikesDestroyRuins = true

# Change this value to false if players shouldn't be allowed to pretarget 
# nuclear warheads.
# Default value is true
g_bEnableNuclearWarheadPretargetting = true

g_plotTypeMapping = {
						"TERRAIN_GRASS" : PlotTypes.PLOT_LAND,
						"TERRAIN_PLAINS" : PlotTypes.PLOT_LAND, 
						"TERRAIN_DESERT" : PlotTypes.PLOT_LAND,
						"TERRAIN_TUNDRA" : PlotTypes.PLOT_LAND,
						"TERRAIN_SNOW" : PlotTypes.PLOT_LAND,
						"TERRAIN_COAST" : PlotTypes.PLOT_OCEAN,
						"TERRAIN_OCEAN" : PlotTypes.PLOT_OCEAN,
						"TERRAIN_PEAK" : PlotTypes.PLOT_PEAK,
						"TERRAIN_HILL" : PlotTypes.PLOT_HILLS
					}

def loadConfigurationValues():
	global g_bNukesDestroyCities
	global g_bNukesAlterLandscape
	global g_strAlterLandscapeTerrain
	global g_bNukesDestroyUnits
	global g_bNukeStrikesDestroyRuins
	global g_bEnableNuclearWarheadPretargetting
	
	config = CvConfigParser.CvConfigParser("MAD Nukes Mod Config.ini")

	if(config != None):
		g_bNukesDestroyCities = config.getboolean("MAD Nukes Mod", "Nukes Destroy Cities", True)
		g_bNukesAlterLandscape = config.getboolean("MAD Nukes Mod", "Nukes Alter Landscape", True)
		g_strAlterLandscapeTerrain = config.get("MAD Nukes Mod", "Alter Landscape Terrain", "TERRAIN_COAST")
		g_bNukesDestroyUnits = config.getboolean("MAD Nukes Mod", "Nukes Destroy Units", True)
		g_bNukeStrikesDestroyRuins = config.getboolean("MAD Nukes Mod", "Nuke Strikes Destroy Ruins", True)
		g_bEnableNuclearWarheadPretargetting = config.getboolean("MAD Nukes Mod", "Enable Nuclear Warhead Pretargetting", True)
		
		if(g_strAlterLandscapeTerrain not in g_plotTypeMapping.keys()):
			g_strAlterLandscapeTerrain = "TERRAIN_COAST"
		
		gc.getGame().setNukeAnywhere(true)
		gc.getGame().setMADNukesEnabled(g_bEnableNuclearWarheadPretargetting)


class CvMADNukesEventManager:

	madNukesManager = None
	
	def __init__(self, eventManager):
		self.EventKeyDown=6
		self.eventManager = eventManager

		eventManager.addEventHandler("unitLost", self.onUnitLost)
		#eventManager.addEventHandler("mouseEvent", self.onMouseEvent)
		eventManager.addEventHandler("kbdEvent",self.onKbdEvent)

		loadConfigurationValues()
		
		self.madNukesManager = CvMADNukesManager.CvMADNukesManager(CvScreenEnums.MAD_NUKES_MANAGER)		


	def onMouseEvent(self, argsList):
		eventType,mx,my,px,py,interfaceConsumed,screens = argsList

		#objPlot = gc.getGame().getLastNukeStrikePlot()

		#CyInterface().addImmediateMessage("%s" %(objPlot.isNone()),"")
		
		objCity = gc.getPlayer(0).getCapitalCity()
		
#		objPlot = objCity.plot()
#		for i in range(objPlot.getNumUnits()):
#			objPlot.getUnit(i).setName("Nuke %s" %(i))
#			if(objPlot.getUnit(i) != None and objPlot.getUnit(i).isMADEnabled()):
#				CyInterface().addImmediateMessage("%s %s" %(objPlot.getUnit(i).getName(),objPlot.getUnit(i).getMADTargetPlot().getPlotCity().getName()),"")
		
		#CyInterface().addImmediateMessage("%s" %(gc.getPlayer(gc.getMap().plot(px,py).getPlotCity().getOwner()).getMADIncoming()),"")
		CyInterface().addImmediateMessage("%s" %(gc.getPlayer(0).getMADOutgoing()),"")
		CyInterface().addImmediateMessage("%s %s" %(gc.getGame().isMADNukesEnabled(), gc.getPlayer(0).isMADNukesEnabled()),"")
		
		
		
	# This method handles the key input and will bring up the nuclear arsenel 
	# manager screen if the player presses the 'ALT-N' key.
	def onKbdEvent(self, argsList):
		'keypress handler - return 1 if the event was consumed'
		# TO DO: REMOVE THE FOLLOWING LINE BEFORE RELEASE.
		#gc.getPlayer(0).setGold(20000)
		eventType,key,mx,my,px,py = argsList
			
		theKey=int(key)

		if ( eventType == self.EventKeyDown and theKey == int(InputTypes.KB_N) and self.eventManager.bAlt and gc.getGame().isMADNukesEnabled() and gc.getPlayer(gc.getGame().getActivePlayer()).isMADNukesEnabled()):
			self.madNukesManager.interfaceScreen()
			
					
	def onUnitLost(self, argsList):
		'Unit Lost'
		objUnit = argsList[0]

		loadConfigurationValues()

		# Only handle the cases where if the unit lost is a nuke
		if(objUnit.getUnitType() == gc.getInfoTypeForString("UNIT_ICBM")):
			self.handleNukeDetonation(objUnit)
		
	
	# This method handles the actual detonation of a nuke. It will basically
	# go through a player's enemy list. For each enemy the method will go
	# through each one of their cities and see if the number of plots with 
	# fallout around a city cross a threshold and perform the appropriate
	# action.
	def handleNukeDetonation(self, objNuke):
	
		# Return immediately if the nuke passed in is invalid
		if(objNuke == None):
			return

		# Return immediately if the nuke passed in is invalid
		if(objNuke.isNone()):
			return

		# Return immediately if the nuke passed in isn't really a nuke.
		if(objNuke.getUnitType() != gc.getInfoTypeForString("UNIT_ICBM")):
			return
		
		# Get the owner of the nuke.	
		iPlayer = objNuke.getOwner()

		objPlot = gc.getGame().getLastNukeStrikePlot()
		
		# Return immediately if no plot was hit
		if(objPlot == None):
			return
			
		# Return immediately if no plot was hit
		if(objPlot.isNone()):
			return
			
		# Return immediately if the plot is not a city plot
		if(not objPlot.isCity()):

			if(g_bNukesAlterLandscape):
				self.devistatePlot(objPlot, iPlayer)
			return
					
		objCity = objPlot.getPlotCity()
		
		falloutPlotList = []
		iTotalNonWaterPlots = -1
				
		# Go through plots adjacent to the city
		for i in range(9):
				
			# Save the plot if it cannot be worked by the city and it 
			# contains fallout
			if(not objCity.canWork(objCity.getCityIndexPlot(i)) and objCity.getCityIndexPlot(i).getFeatureType() == gc.getInfoTypeForString("FEATURE_FALLOUT")):
				falloutPlotList.append(objCity.getCityIndexPlot(i))

			# Increment the iTotalNonWaterPlots counter if the plot is 
			# water
			if(not objCity.getCityIndexPlot(i).isWater()):
				iTotalNonWaterPlots+=1
				
		# Calculate the fallout threshold	
		iFalloutThreshold = iTotalNonWaterPlots/2

		# If the number of plots with fallout exceed the fallout 
		# threshold then perform the appropriate action
		if(len(falloutPlotList) >= iFalloutThreshold):
			# Get the plot the city is on
			objCityPlot = objCity.plot()

			if(g_bNukesAlterLandscape):
				objCity.kill()
				self.devistatePlot(objCityPlot, iPlayer)
			else:
				# Destroy the route that was on the same plot as the city
				objCityPlot.setRouteType(gc.getInfoTypeForString("NO_ROUTE"))
							
				# Go through all of the units in the city and kill them off 
				# if the mod is configured to do so
				if(g_bNukesDestroyUnits):
					for i in range(objCityPlot.getNumUnits()):
						objCityPlot.getUnit(i).kill(true,iPlayer)
						
				# Kill the city	if mod is configured to do so
				if(g_bNukesDestroyCities):
					objCity.kill()
						
				# Destroy the improvement that was on the same plot as the 
				# city if mod is configured to do so
				if(g_bNukeStrikesDestroyRuins):
					objCityPlot.setImprovementType(gc.getInfoTypeForString("NO_IMPROVEMENTS"))

		# Refresh and redraw the interface
		CyInterface().setDirty(InterfaceDirtyBits.MinimapSection_DIRTY_BIT, true)
		CyInterface().setDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT, true)


	# Completely devistates the plot that the city is on and turns it into an
	# ocean plot.
	def devistatePlot(self, objPlot, iPlayer):

		# Return immediately if the plot passed in is invalid
		if(objPlot == None):
			return

		# Return immediately if the plot passed in is invalid
		if(objPlot.isNone()):
			return
		
		# Return an empty list immediately if the player passed in is invalid
		if(iPlayer < 0):
			return 

		objPlayer = gc.getPlayer(iPlayer)

		# Return an empty list immediately if the player passed in is invalid
		if(objPlayer == None):
			return 

		# Return an empty list immediately if the player passed in is invalid
		if(objPlayer.isNone()):
			return 

		# Go through all of the units in the city and kill them off
		for i in range(objPlot.getNumUnits()):
			objPlot.getUnit(i).kill(true,iPlayer)

		# Destroy the improvement that was on the same plot
		objPlot.setImprovementType(gc.getInfoTypeForString("NO_IMPROVEMENTS"))

		# Destroy the route that was on the same plot
		objPlot.setRouteType(gc.getInfoTypeForString("NO_ROUTE"))
		
		# Change the plot type of the plot where the city was
		objPlot.setPlotType(PlotTypes(g_plotTypeMapping[g_strAlterLandscapeTerrain]), True, True)
			
		# Refresh and redraw the interface
		CyInterface().setDirty(InterfaceDirtyBits.MinimapSection_DIRTY_BIT, true)
		CyInterface().setDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT, true)			
	
	